require 'derketo/tracer'
require 'derketo/serializers/mermaid'

module Derketo
  class Middleware
    def initialize(app)
      @app = app
    end

    def call(env)
      tracer = Derketo::Tracer.new(ENV['DERKETO_ROOT'])
      response = tracer.trace(@app.call(env))
      serializaton = Derketo::Serializers::Mermaid.new(tracer).serialize
      Derketo::Helpers.write('./tmp/derketo.mmd', serialization)
      response
    end
  end
end
