require 'derketo/helpers'
module Derketo
  module Serializers
    class Mermaid
      include Derketo::Helpers

      attr_accessor :text
      def initialize(tracer)
        events = tracer.events.all
        @text = "sequenceDiagram\n"
        events.map(&:class_name).uniq.map do |class_name|
          @text << participant(class_name)
        end
        @text << events.map(&:to_mermaid).join
      end

      def participant(class_name)
        "\tparticipant #{class_name}\n"
      end

      def serialize
        @text
      end
    end
  end
end
