require 'derketo/event_trace'
require 'derketo/events/call'
require 'derketo/events/return'
module Derketo
  class Tracer
    attr_accessor :events
    def initialize(scope: nil)
      @events = Derketo::EventTrace.new
      @tracepoint = TracePoint.new(:call, :return) do |tp|
        if scope.nil? || tp.path.include?(scope)
          if tp.event == :call
            @events.push(Derketo::Events::Call.new(tp))
          elsif tp.event == :return
            @events.push(Derketo::Events::Return.new(tp))
          end
        end
      end
    end

    def trace
      @tracepoint.enable
      response = yield
      @tracepoint.disable
      response
    end
  end
end
